#GRL Estimation
library("MASS")

rm(list=ls(all=TRUE))
# setwd("C:/workspace_R")

binit <- c(0,0,0) # initial value of the parameter

inpput_area<-"C:/bike_summerschool/"
input_project<-"data"

inputnodepass<-paste(inpput_area, input_project, "network/reduced_node.csv", sep = "/")
inputdatapass<-paste(inpput_area, input_project, "bike_reduced_route_11.csv", sep = "/") #10以下切り捨て（１１リンク以上）
inputlinkpass<-paste(inpput_area, input_project, "network/reduced_link.csv", sep = "/")
inputmatrixpass<-paste(inpput_area, input_project, "network/reduced_matrix.csv", sep = "/")
inputRigthpass<-paste(inpput_area, input_project, "network/reduced_rightturn.csv", sep = "/")



########## node data reading ############
node <- read.csv(inputnodepass)
nodeid <- sort(unique(node$NodeID))
N <- length(nodeid)


readdata.number <- -1 # -1 = all
# samplingdummy <- 0 # 1 = sampling , 0 = all
#sampling.numbaer <- 100

############### time measure ############
message("PROGRAM START!\n")
t<-proc.time()


#########################################
########  reading & sampling    #########
#########################################


########## result data reading ##########
data <- read.csv(inputdatapass, nrows = readdata.number)
names(data) <- c("k","a","d")
#data <- data[(nrow(data) - 700 + 1):nrow(data),]
# if(samplingdummy == 1){
#   spl <- sample((1:nrow(data)),sampling.numbaer)
#   spldata <- data.frame("k"=c(-1),"a"=c(-1),"d"=c(-1))
#   for(i in length(spl)){
#     spldata <- rbind(spldata,data[spl,])
#   }
#   data <- subset(spldata,spldata$k>0)
# }
ddata <- sort(unique(data$d))
kdata <- list()
dataList <- list()
for(i in 1:length(ddata)){
  sub <- subset(data,data$d == ddata[i])
  kdata[[i]] <- sort(unique(sub$k)) 
  dataList[[i]] <- sub
  #print(dataList)
}
########## link data reading ############
link <- read.csv(inputlinkpass)
linkid <- sort(unique(link$LinkID))
L <- length(linkid)
##
if(any(link$Speed == 0))
  link$Speed[link$Speed == 0] <- 1
#print(link$Speed)
########## link matrix reading ##########
matrix <- read.csv(inputmatrixpass)
Length_m <- length(matrix$k)

names(matrix) <- c("k","a")
asetdataList <-list()
matrixList <- list()
for(j in 1:length(ddata)){
  asetdata<-c()
  submatrix <- data.frame("k"=c(-1),"a"=c(-1))
  #print(submatrix)
  for(i in 1:length(kdata[[j]])){
    sub <- subset(matrix, matrix$k == kdata[[j]][i])
    submatrix <- rbind(submatrix,sub)
    asetdata <- c(asetdata, sub$a)
  }
  asetdataList[[j]] <- sort(unique(asetdata))
  matrixList[[j]] <- subset(submatrix,submatrix$k>0)
}

#
AList <- list()
for(k in 1:L){
  kl <- linkid[k]
  sub <- subset(matrix, matrix$k == kl)
  AList[[k]] <- sub$a
}

################# index #################
dlength <- length(ddata)
llength <- length(link$LinkID)
D <- length(unique(data$d))
L <- length(linkid)

################# value function #################
V0 <- array(-1, dim = c(L, D))
z0 <- exp(V0)

########### right turn dummy ############
Right <- read.csv(inputRigthpass,header=T) #, header=F
names(Right) <- c("k","a")

RR <- array(exp(0), dim = c(L, L))
for(s in 1:nrow(Right)){
  kl <- Right$k[s]
  al <- Right$a[s]
  k<-(1:length(linkid))[linkid == kl]
  a<-(1:length(linkid))[linkid == al]
  RR[k,a] <- exp(1)
}
#print(RR)
#RR <- as(RR, "sparseMatrix")

########### the number of Lane ############
#LA <- array(exp(0), dim = c(L, L))
#for(k in 1:L){
#  kn <- link[k,]
#  kn <- kn$LinkID
#  for(a in 1:L){
#    an <- linkid[a]
#    ka <-(1:Length_m)[matrix[,1] == kn & matrix[,2] == an]
#    
#    if(length(ka)==0){
#      LA[k,a] <- exp(0)
#    }else{
#      LA[k,a] <- exp(link$Lane[k])
#    }
#  }
#}

######### link connectiuon dummy ########
I <- array(0, dim = c(L, L))
names(matrix) <- c("k","a")
for(i in 1:nrow(matrix)){
  kl <- matrix$k[i]
  al <- matrix$a[i]
  k <- (1:length(linkid))[linkid == kl]
  a <- (1:length(linkid))[linkid == al]
  I[k,a] <- 1
}
Ilist <- list()
for(d in 1:D){
  dl <- ddata[d]
  #print(ddata[d]) # Mage weda
  #print(is.na(ddata[d])) # Mage weda
  
  dn<-(1:length(linkid))[linkid == dl]
  Id <- I
  Id[dn, ] <- 0
  #print(Id) # Mage weda
  for(k in 1:L){
    aList <- AList[[k]]
    if(is.element(dl, aList)){
      Id[k, ] <- 0
      Id[k, dn] <- 1
      #print(Id) # Mage weda
    }
  }
  Ilist[[d]] <- Id
  #
  V0[dn,d] <- 0
  z0[dn,d] <- 1
  #print(z0) # Mage weda
}

############ parameter init #############
b <- binit
V <- V0
z <- z0

tt <- array(exp(0), dim = c(1, L))
for(a in 1:L){
  tt[1,a] <- exp(0.6*(link$Length[a]))
  # tt[1,a] <- exp(0.6*(link$Length[a]/link$Speed[a]))
}
TT <- array(rep(tt), dim = c(L, L))
#TT <- matrix(rep(tt), nrow = L, ncol = L) 
TT <- t(TT) #

#la <- array(exp(0), dim = c(1, L))
#for(a in 1:L){
#  la[1,a] <- exp(link$Lane[a])
#  # tt[1,a] <- exp(0.6*(link$Length[a]/link$Speed[a]))
#}
#LA <- array(rep(la), dim = c(L, L))
##TT <- matrix(rep(tt), nrow = L, ncol = L) 
#LA <- t(LA) #
#########################################
######## log-likelihood function ########
#########################################
fr <- function(x) { 
  # ############### time measure ############
  # message("LL Calculation!\n")
  # tLL<-proc.time()
  
  LL <- 0 
  theta <- exp(x[3])/(1+exp(x[3]))
  #theta=x[3]
  
  for(d in 1:D){
    dn <- (1:L)[linkid == ddata[d]]
    
    dd <- ddata[d]
    Id <- Ilist[[d]]
    z <- array(exp(theta*V[,d]), dim = c(L, 1))
    ZD <-  array(rep(z), dim = c(L, L))
    ZD <- t(ZD)
    #M <- as(Id*(TT^x[1])*(RR^x[2]), "sparseMatrix")
    M <- Id*(TT^x[1])*(RR^x[2])
    Mz <- (M%*%z != 0)*(M%*%z) + (M%*%z == 0)
    MZ <- array(rep(Mz), dim = c(L,L))
    p <- (M*ZD)/MZ
    p <- (p == 0)*1 + (p != 0)*p
    
    klink <- dataList[[d]]$k 
    alink <- dataList[[d]]$a 
    #
    hhd <- nrow(dataList[[d]])
    
    for(h in 1:hhd){
    
      pka <- 0
      
      if(alink[h] == dd){
        pka <- 1
      }else{
        k <- (1:L)[linkid == klink[h]]
        a <- (1:L)[linkid == alink[h]]
        # print(paste("k is",k)) # Mage weda
        # print(paste("a is",a)) # Mage weda
        # print(paste("p[k,a] is",p[k,a])) # Mage weda
        if(p[k,a] == 0 ){
          pka <- 1
        }else{
          pka <- p[k,a]
        }
      }
      
      # if((alink[h] == dd) || p[k,a] == 0 ){
      #  pka <- 1
      # }else{
      #  pka <- p[k,a]
      # }
      LL <- LL + log(pka)
    }
    #print(proc.time()-t)
  }
  print(LL)
  
  # ########## calculation time #############
  # print(proc.time()-tLL)
  # message("LL Calculation Finish!\n")
  
  return(LL)
}

#########################################
############ value function #############
#########################################
newV <- function(x) {
  #theta=x[3]
  theta <- exp(x[3])/(1+exp(x[3])) #
  
  z <- matrix(1, nrow = L, ncol = D) #exp(Vd)
  V <- array(0, dim = c(L, D))
  i <- 0
  for (d in 1:D){
    kd <- (1:length(linkid))[linkid == ddata[d]]
    z[kd, d] <- 1
    
    M <- matrix(0, nrow = L, ncol = L) #
    B <- matrix(0, nrow = L, ncol = 1) #
    B[kd, 1] <- 1
    
    #
    Id <- Ilist[[d]]
    
    #
    for (k in 1:L){
      for (a in 1:L){
        Ika <- Id[k, a]
        if(Ika == 1){
          if(a == kd){
            M[k, a] <- 1 #
          }else{
            M[k, a] <- exp(x[1]*0.6*(link$Length[a]))*(RR[k,a]^x[2])
            # M[k, a] <- exp(x[1]*0.6*(link$Length[a]/link$Speed[a]) + x[2]*RR[k,a])
            #x[1]*link$Length[a]/10 ,  Uturn[k,a],  + x[3]*(link$Lane[a] == 1)
          }
        } #else
      }
    } #for k
    
    #
    dL <- 100
    zi <- matrix(z[,d], nrow = L, ncol = 1)
    while(dL > 0.01){
      zii <- zi
      Xz <- (zii)^theta
      zi <- M %*% Xz + B
      dL <- sum(abs(zii - zi))
      i <- i + 1
    } #while
    z[,d] <- zi
    zi <- (zi == 0)*1 + (zi != 0)*zi
    V[,d] <- log(zi)
  } #for d
  print(i)
  return(z)
}

#########################################
######### actual program area ###########
######### structural estimtion ##########
#########################################
dL <- 100
n <- 0
while(dL>=0.01){
  n <- n + 1
  
  b0 <- b
  z <- z0
  V <- V0
  
  res <- optim(b0, fr, method = "Nelder-Mead", hessian = TRUE, control=list(fnscale=-1))
  b <- res$par
  cat("b  =")
  print(b)
  cat("lnL=")
  print(res$value)
  #updating value funciton
  z0 <- newV(b)
  
  #convergence condition
  #  dL <- sum(abs(V - V0)) + sum(abs(b - b0))
  zz <- (z == 0)*1 + (z != 0)*z
  V <- log(zz)
  zz0 <- (z0 == 0)*1 + (z0 != 0)*z0
  V0 <- log(zz0)
  #cat("V0 =")
  #print(V0)
  dL <- sum(abs(V - V0)) + sum(abs(b - b0))
  cat("dL =")
  print(dL)
}

hhh <- res$hessian
print(n)
tval <- b/sqrt(-diag(solve(hhh)))
LL <- res$value
# Vfin <- V0
#V <- array(0, dim = c(L, D))
#L0 <- fr(binit)
binit[3] <- b[3]
# V <- newV(binit)
Lc <- fr(binit)

##########  estimation result ###########
print(res)
print(Lc) 
print(LL)
print((Lc-LL)/Lc) 
print((Lc-(LL-length(b)))/Lc) 
print(b)
#theta=b[3]
theta <- exp(b[3])/(1+exp(b[3]))
print(theta)
print(tval)

tval2 <- b/sqrt(-diag(ginv(hhh)))##???????苁?߂?t?l
print(tval2)

########## calculation time #############
message("ALL COMPLETED!\n")
print(proc.time()-t)